org.apache.ignite.internal

## Interface GridKernalContext

All Superinterfaces:
  Iterable<GridComponent>

All Known Implementing Classes:
  GridKernalContextImpl, StandaloneGridKernalContext

    @GridToStringExclude
    public interface GridKernalContext
    extends Iterable<GridComponent>

### Method Summary

All Methods Instance Methods Abstract Methods
`Object` `addNodeAttribute(String key, Object val)` Add attribute to node attributes.
`GridAffinityProcessor` `affinity()` Gets cache data affinity processor.
`GridCacheProcessor` `cache()` Gets caches processor.
`IgniteCacheObjectProcessor` `cacheObjects()` Gets cache object processor.
`GridCheckpointManager` `checkpoint()` Gets checkpoint manager.
`boolean` `clientDisconnected()`
`ClientListenerProcessor` `clientListener()` Gets client listener processor.
`boolean` `clientNode()`
`GridClosureProcessor` `closure()` Gets closure processor.
`ClusterProcessor` `cluster()` Gets Cluster processor.
`GridCollisionManager` `collision()` Gets collision manager.
`List<GridComponent>` `components()` Gets list of all grid components in the order they were added.
`CompressionProcessor` `compress()`
`IgniteConfiguration` `config()` Gets grid configuration.
`GridContinuousProcessor` `continuous()` Gets event continuous processor.
`MvccProcessor` `coordinators()`
`<T> T` `createComponent(Class<T> cls)` Creates optional component.
`<K,V> DataStreamProcessor<K,V>` `dataStream()` Gets data streamer processor.
`DataStructuresProcessor` `dataStructures()` Gets data structures processor.
`IgniteDefragmentation` `defragmentation()` Gets defragmentation manager.
`GridDeploymentManager` `deploy()` Gets deployment manager.
`DiagnosticProcessor` `diagnostic()` Gets diagnostic processor.
`GridDiscoveryManager` `discovery()` Gets discovery manager.
`DistributedConfigurationProcessor` `distributedConfiguration()` Gets distributed configuration processor.
`DistributedMetaStorage` `distributedMetastorage()` Gets global metastorage.
`DurableBackgroundTasksProcessor` `durableBackgroundTask()`
`GridEncryptionManager` `encryption()` Gets encryption manager.
`GridEventStorageManager` `event()` Gets event storage manager.
`IgniteExceptionRegistry` `exceptionRegistry()` Gets exception registry.
`GridFailoverManager` `failover()` Gets failover manager.
`FailureProcessor` `failure()` Gets failure processor.
`GridKernalGateway` `gateway()` Gets kernal gateway.
`Executor` `getAsyncContinuationExecutor()` Executor that is in charge of processing user async continuations.
`IgniteEx` `grid()` Gets grid instance managed by kernal.
`boolean` `hasNodeAttribute(String key)` Check if node has specified attribute.
`String` `igniteInstanceName()` Gets Ignite instance name.
`GridIndexingManager` `indexing()` Gets indexing manager.
`IndexProcessor` `indexProcessor()` Indexes processor.
`GridInternalSubscriptionProcessor` `internalSubscriptionProcessor()`
`boolean` `invalid()` Checks whether this node is invalid due to a critical error or not.
`GridIoManager` `io()` Gets communication manager.
`boolean` `isStopping()`
`GridJobProcessor` `job()` Gets job processor.
`GridJobMetricsProcessor` `jobMetric()` Gets job metric processor.
`GridLoadBalancerManager` `loadBalancing()` Gets load balancing manager.
`UUID` `localNodeId()` Gets local node ID.
`IgniteLogger` `log(Class<?> cls)` Gets logger for given class.
`IgniteLogger` `log(String ctgr)` Gets logger for given category.
`LongJVMPauseDetector` `longJvmPauseDetector()` Gets long JVM pause detector.
`MaintenanceRegistry` `maintenanceRegistry()` Gets maintenance registry.
`GridMarshallerMappingProcessor` `mapping()` Gets grid marshaller mapping processor.
`MarshallerContextImpl` `marshallerContext()` Gets marshaller context.
`GridMetricManager` `metric()` Gets metric manager.
`Object` `nodeAttribute(String key)` Get node attribute by name.
`Map<String,Object>` `nodeAttributes()`
`PdsFoldersResolver` `pdsFolderResolver()`
`GridPerformanceSuggestions` `performance()`
`PerformanceStatisticsProcessor` `performanceStatistics()` Gets Performance statistics processor.
`PlatformProcessor` `platform()`
`PluginProvider` `pluginProvider(String name)`
`IgnitePluginProcessor` `plugins()`
`PoolProcessor` `pools()` Gets pool processor.
`GridPortProcessor` `ports()` Gets port processor.
`void` `printMemoryStats()` Print grid kernal memory stats (sizes of internal structures, etc.).
`GridQueryProcessor` `query()` Gets query processor.
`boolean` `recoveryMode()`
`GridResourceProcessor` `resource()` Gets resource processor.
`IgniteRestProcessor` `rest()` Gets REST processor.
`IgniteScheduleProcessorAdapter` `schedule()` Gets schedule processor.
`IgniteSecurity` `security()` Gets instance of `IgniteSecurity`.
`GridSegmentationProcessor` `segmentation()` Gets segmentation processor.
`boolean` `segmented()` Checks whether this node detected its segmentation from the rest of the grid.
`IgniteServiceProcessor` `service()` Gets service processor.
`GridTaskSessionProcessor` `session()` Gets task session processor.
`GridClusterStateProcessor` `state()` Gets cluster state processor.
`GridSystemViewManager` `systemView()` Gets system view manager.
`GridTaskProcessor` `task()` Gets task processor.
`GridTimeoutProcessor` `timeout()` Gets timeout processor.
`Tracing` `tracing()` Gets tracing processor.
`Thread.UncaughtExceptionHandler` `uncaughtExceptionHandler()`
`String` `userVersion(ClassLoader ldr)` Gets user version for given class loader by checking `META-INF/ignite.xml` file for `userVersion` attribute.
`WorkersRegistry` `workersRegistry()` Gets workers registry.

### Methods inherited from interface java.lang.Iterable

`forEach, iterator, spliterator`

### Method Detail

#### components

    List<GridComponent> components()

Gets list of all grid components in the order they were added.

Returns:
  List of all grid components in the order they were added.

#### localNodeId

    UUID localNodeId()

Gets local node ID.

Returns:
  Local node ID.

#### igniteInstanceName

    String igniteInstanceName()

Gets Ignite instance name.

Returns:
  Ignite instance name.

#### log

    IgniteLogger log(String ctgr)

Gets logger for given category.

Parameters:
  `ctgr` - Category.
Returns:
  Logger.

#### log

    IgniteLogger log(Class<?> cls)

Gets logger for given class.

Parameters:
  `cls` - Class to get logger for.
Returns:
  Logger.

#### isStopping

    boolean isStopping()

Returns:
  `True` if grid is in the process of stopping.

#### gateway

    GridKernalGateway gateway()

Gets kernal gateway.

Returns:
  Kernal gateway.

#### grid

    IgniteEx grid()

Gets grid instance managed by kernal.

Returns:
  Grid instance.

#### config

    IgniteConfiguration config()

Gets grid configuration.

Returns:
  Grid configuration.

#### task

    GridTaskProcessor task()

Gets task processor.

Returns:
  Task processor.

#### affinity

    GridAffinityProcessor affinity()

Gets cache data affinity processor.

Returns:
  Cache data affinity processor.

#### job

    GridJobProcessor job()

Gets job processor.

Returns:
  Job processor

#### timeout

    GridTimeoutProcessor timeout()

Gets timeout processor.

Returns:
  Timeout processor.

#### resource

    GridResourceProcessor resource()

Gets resource processor.

Returns:
  Resource processor.

#### jobMetric

    GridJobMetricsProcessor jobMetric()

Gets job metric processor.

Returns:
  Metrics processor.

#### metric

    GridMetricManager metric()

Gets metric manager.

Returns:
  Monitoring manager.

#### maintenanceRegistry

    MaintenanceRegistry maintenanceRegistry()

Gets maintenance registry.

Returns:
  Maintenance registry.

#### systemView

    GridSystemViewManager systemView()

Gets system view manager.

Returns:
  Monitoring manager.

#### cache

    GridCacheProcessor cache()

Gets caches processor.

Returns:
  Cache processor.

#### state

    GridClusterStateProcessor state()

Gets cluster state processor.

Returns:
  Cluster state processor.

#### distributedMetastorage

    DistributedMetaStorage distributedMetastorage()

Gets global metastorage.

Returns:
  Global metastorage.

#### distributedConfiguration

    DistributedConfigurationProcessor distributedConfiguration()

Gets distributed configuration processor.

Returns:
  Distributed configuration processor.

#### tracing

    Tracing tracing()

Gets tracing processor.

Returns:
  Tracing processor.

#### session

    GridTaskSessionProcessor session()

Gets task session processor.

Returns:
  Session processor.

#### closure

    GridClosureProcessor closure()

Gets closure processor.

Returns:
  Closure processor.

#### service

    IgniteServiceProcessor service()

Gets service processor.

Returns:
  Service processor.

#### ports

    GridPortProcessor ports()

Gets port processor.

Returns:
  Port processor.

#### schedule

    IgniteScheduleProcessorAdapter schedule()

Gets schedule processor.

Returns:
  Schedule processor.

#### rest

    IgniteRestProcessor rest()

Gets REST processor.

Returns:
  REST processor.

#### segmentation

    GridSegmentationProcessor segmentation()

Gets segmentation processor.

Returns:
  Segmentation processor.

#### dataStream

    <K,V> DataStreamProcessor<K,V> dataStream()

Gets data streamer processor.

Returns:
  Data streamer processor.

#### continuous

    GridContinuousProcessor continuous()

Gets event continuous processor.

Returns:
  Event continuous processor.

#### pools

    PoolProcessor pools()

Gets pool processor.

Returns:
  Pool processor.

#### mapping

    GridMarshallerMappingProcessor mapping()

Gets grid marshaller mapping processor.

Returns:
  Mapping processor.

#### cacheObjects

    IgniteCacheObjectProcessor cacheObjects()

Gets cache object processor.

Returns:
  Cache object processor.

#### query

    GridQueryProcessor query()

Gets query processor.

Returns:
  Query processor.

#### clientListener

    ClientListenerProcessor clientListener()

Gets client listener processor.

Returns:
  Client listener processor.

#### plugins

    IgnitePluginProcessor plugins()

Returns:
  Plugin processor.

#### deploy

    GridDeploymentManager deploy()

Gets deployment manager.

Returns:
  Deployment manager.

#### io

    GridIoManager io()

Gets communication manager.

Returns:
  Communication manager.

#### discovery

    GridDiscoveryManager discovery()

Gets discovery manager.

Returns:
  Discovery manager.

#### checkpoint

    GridCheckpointManager checkpoint()

Gets checkpoint manager.

Returns:
  Checkpoint manager.

#### event

    GridEventStorageManager event()

Gets event storage manager.

Returns:
  Event storage manager.

#### failover

    GridFailoverManager failover()

Gets failover manager.

Returns:
  Failover manager.

#### collision

    GridCollisionManager collision()

Gets collision manager.

Returns:
  Collision manager.

#### security

    IgniteSecurity security()

Gets instance of `IgniteSecurity`.

Returns:
  Ignite security.

#### loadBalancing

    GridLoadBalancerManager loadBalancing()

Gets load balancing manager.

Returns:
  Load balancing manager.

#### indexing

    GridIndexingManager indexing()

Gets indexing manager.

Returns:
  Indexing manager.

#### indexProcessor

    IndexProcessor indexProcessor()

Indexes processor.

Returns:
  Indexes processor.

#### encryption

    GridEncryptionManager encryption()

Gets encryption manager.

Returns:
  Encryption manager.

#### defragmentation

    IgniteDefragmentation defragmentation()

Gets defragmentation manager.

Returns:
  Defragmentation manager.

#### workersRegistry

    WorkersRegistry workersRegistry()

Gets workers registry.

Returns:
  Workers registry.

#### dataStructures

    DataStructuresProcessor dataStructures()

Gets data structures processor.

Returns:
  Data structures processor.

#### longJvmPauseDetector

    LongJVMPauseDetector longJvmPauseDetector()

Gets long JVM pause detector.

Returns:
  Long JVM pause detector.

#### diagnostic

    DiagnosticProcessor diagnostic()

Gets diagnostic processor.

Returns:
  Diagnostic processor.

#### invalid

    boolean invalid()

Checks whether this node is invalid due to a critical error or not.

Returns:
  `True` if this node is invalid, `false` otherwise.

#### segmented

    boolean segmented()

Checks whether this node detected its segmentation from the rest of the grid.

Returns:
  `True` if this node has segmented, `false` otherwise.

#### failure

    FailureProcessor failure()

Gets failure processor.

#### printMemoryStats

    void printMemoryStats()

Print grid kernal memory stats (sizes of internal structures, etc.). NOTE: This method is for testing and profiling purposes only.

#### performance

    GridPerformanceSuggestions performance()

Returns:
  Performance suggestions object.

#### userVersion

    String userVersion(ClassLoader ldr)

Gets user version for given class loader by checking `META-INF/ignite.xml` file for `userVersion` attribute. If `ignite.xml` file is not found, or user version is not specified there, then default version (empty string) is returned.

Parameters:
  `ldr` - Class loader.
Returns:
  User version for given class loader or empty string if no version was explicitly specified.

#### pluginProvider

    PluginProvider pluginProvider(String name)
                           throws PluginNotFoundException

Parameters:
  `name` - Plugin name.
Returns:
  Plugin provider instance.
Throws:
  `PluginNotFoundException` - If plugin provider for the given name was not found.

#### createComponent

    <T> T createComponent(Class<T> cls)

Creates optional component.

Parameters:
  `cls` - Component class.
Returns:
  Created component.

#### exceptionRegistry

    IgniteExceptionRegistry exceptionRegistry()

Gets exception registry.

Returns:
  Exception registry.

#### nodeAttribute

    Object nodeAttribute(String key)

Get node attribute by name.

Parameters:
  `key` - Attribute name.
Returns:
  Attribute value.

#### hasNodeAttribute

    boolean hasNodeAttribute(String key)

Check if node has specified attribute.

Parameters:
  `key` - Attribute name.
Returns:
  `true` If node has attribute with specified name.

#### addNodeAttribute

    Object addNodeAttribute(String key,
                            Object val)

Add attribute to node attributes.

Parameters:
  `key` - Attribute name.
  `val` - Attribute value.
Returns:
  Previous attribute value associated with attribute name.

#### nodeAttributes

    Map<String,Object> nodeAttributes()

Returns:
  Node attributes.

#### cluster

    ClusterProcessor cluster()

Gets Cluster processor.

Returns:
  Cluster processor.

#### marshallerContext

    MarshallerContextImpl marshallerContext()

Gets marshaller context.

Returns:
  Marshaller context.

#### clientNode

    boolean clientNode()

Returns:
  `True` if local node is client node (has flag `IgniteConfiguration.isClientMode()` set).

#### clientDisconnected

    boolean clientDisconnected()

Returns:
  `True` if local node in disconnected state.

#### platform

    PlatformProcessor platform()

Returns:
  Platform processor.

#### coordinators

    MvccProcessor coordinators()

Returns:
  Cache mvcc coordinator processor.

#### pdsFolderResolver

    PdsFoldersResolver pdsFolderResolver()

Returns:
  PDS mode folder name resolver, also generates consistent ID in case new folder naming is used

#### internalSubscriptionProcessor

    GridInternalSubscriptionProcessor internalSubscriptionProcessor()

Returns:
  subscription processor to manage internal-only (strict node-local) subscriptions between components.

#### uncaughtExceptionHandler

    Thread.UncaughtExceptionHandler uncaughtExceptionHandler()

Returns:
  Default uncaught exception handler used by thread pools.

#### compress

    CompressionProcessor compress()

Returns:
  Compression processor.

#### recoveryMode

    boolean recoveryMode()

Returns:
  `True` if node is in recovery mode (before join to topology).

#### durableBackgroundTask

    DurableBackgroundTasksProcessor durableBackgroundTask()

Returns:
  Local continuous tasks processor.

#### performanceStatistics

    PerformanceStatisticsProcessor performanceStatistics()

Gets Performance statistics processor.

Returns:
  Performance statistics processor.

#### getAsyncContinuationExecutor

    Executor getAsyncContinuationExecutor()

Executor that is in charge of processing user async continuations.

Returns:
  Executor that is in charge of processing user async continuations.

${current.year} Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Database and Caching Platform | : ver. 2.15.0
Release Date | : April 25 2023